package com.njcn.bpm.service;


import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.baomidou.mybatisplus.extension.service.IService;
import com.njcn.bpm.pojo.param.BpmFormParam;
import com.njcn.bpm.pojo.po.BpmForm;
import com.njcn.bpm.pojo.vo.BpmFormVO;
import com.njcn.bpm.utils.CollectionUtils;

import java.util.Collection;
import java.util.List;
import java.util.Map;


/**
 * 动态表单 Service 接口
 *
 * @author  @风里雾里
 */
public interface IBpmFormService extends IService<BpmForm> {

    /**
     * 创建动态表单
     *
     * @return 编号
     */
    String createForm(BpmFormParam bpmFormParam);

    /**
     * 更新动态表单
     *
     */
    void updateForm(BpmFormParam.BpmFormUpdateParam updateParam);

    /**
     * 删除动态表单
     *
     * @param id 编号
     */
    void deleteForm(List<String>  id);



    /**
     * 获得动态表单列表
     *
     * @return 动态表单列表
     */
    List<BpmForm> getFormList();

    /**
     * 获得动态表单列表
     *
     * @param ids 编号
     * @return 动态表单列表
     */
    List<BpmForm> getFormList(Collection<String> ids);

    /**
     * 获得动态表单 Map
     *
     * @param ids 编号
     * @return 动态表单 Map
     */
    default Map<String, BpmForm> getFormMap(Collection<String> ids) {
        return CollectionUtils.convertMap(this.getFormList(ids), BpmForm::getId);
    }

    /**
     * 获得动态表单分页
     *
     * @return 动态表单分页
     */
    Page<BpmFormVO> getFormPage(BpmFormParam.BpmFormQueryParam bpmFormQueryParam);

}
